Bug 233978 - gbd mystificates me about address bounds
gbd mystificates me about address bounds
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: gdb (Show other bugs)
rawhide
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Jan Kratochvil
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-03-26 09:51 EDT by Adam Tkac
Modified: 2013-04-30 19:35 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-03-26 12:23:21 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
core dump (12.22 MB, application/octet-stream)
2007-03-26 09:52 EDT, Adam Tkac
no flags Details
`rpm -qa|gzip' for easier core file reproducibility (5.17 KB, application/octet-stream)
2007-03-26 12:16 EDT, Jan Kratochvil
no flags Details

  None (edit)
Description Adam Tkac 2007-03-26 09:51:10 EDT
Description of problem:
When I debug attached core file (xorg's, you have to install
xorg-x11-server-Xorg-1.2.99.902-1.fc7 and vnc-server-4.1.2-15.fc7 with
debuginfos, arch x86_64) gdb prints that <Address 0x2aaab4aad052 out of bounds>
but I'm sure that this address isn't out of bounds

Version-Release number of selected component (if applicable):
rpm -q gdb
gdb-6.6-7.fc7

How reproducible:
Always

Steps to Reproduce:
1. run gdb /usr/bin/Xorg <attached core>
2. backtrace
3. see output
  
Actual results:
out of bounds information isn't true

Expected results:
no mystifications about address bounds

Additional info:
If you need anything ping me on irc :)
Comment 1 Adam Tkac 2007-03-26 09:52:24 EDT
Created attachment 150898 [details]
core dump
Comment 2 Jan Kratochvil 2007-03-26 12:16:22 EDT
Created attachment 150909 [details]
`rpm -qa|gzip' for easier core file reproducibility
Comment 3 Jan Kratochvil 2007-03-26 12:23:21 EDT
I believe you are referring to the backtrace lines (just guessing, please
provide a more specific bugreport next time) like:
#11 0x00000000004d0c4e in miBSGetImage (pDrawable=0xa47bf0, sx=33, sy=816, w=62,
h=1, format=2, 
    planemask=18446744073709551615, pdstLine=0x2aaab4aad052 <Address
0x2aaab4aad052 out of bounds>) at mibstore.c:609

Your core file contains these (sorted) memory entries:
  LOAD           0x00000000002b2000 0x00002aaab48af000 0x0000000000000000
                 0x00000000001f5000 0x00000000001f5000  RW     1000
(ends at 0x2aaab4aa4000)
  LOAD           0x00000000004a7000 0x00002aaab4abd000 0x0000000000000000
                 0x0000000000000000 0x000000000000a000  R E    1000

The backtraced address 0x2aaab4aad052 lies between them so there is no mapping
for this memory area and the GDB `out of bounds' error is appropriate in such case.

You should have `/proc/PID/maps' content from the process while it was running
as while it is Xorg(1) I believe that range was a mapped device memory / MMIO
area as in the sample case:
2aaaad75c000-2aaaadf5c000 rw-s fc000000 00:0f 1947                       /dev/mem

`pdstLine' looks there to be a reference to the memory being drawn to.

While this is a Linux kernel Bug type (GDB) it is even NOTABUG for kernel as it
makes no sense (and it would be dangerous) to try to dump mapped device areas to
the core files.

Thanks to notifying me to be aware of this kind of problem in the possible
reports next time.
Comment 4 Adam Tkac 2007-03-27 05:14:04 EDT
Yeah, this really isn't a bug. Sorry for false alarm :)

-A-

Note You need to log in before you can comment on or make changes to this bug.